VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private r_lngWindow As Long
Private m_lngWindowProc As Long
Private m_booHooked As Boolean
Public Event WindowsProcedure(ByRef Message As WindowsMessages, ByRef wParam As Long, ByRef OtherData As Long, ByRef WindowProcResult As Long)
Private r_booInProc As Boolean
Private r_cwlWindowList As CWindowList
Public Property Get Window() As Long
    Window = r_lngWindow
End Property

Public Property Let Window(ByVal v_lngWindow As Long)
    r_lngWindow = v_lngWindow
End Property

Public Property Get Caption() As String
    Dim m_strBuffer As String
    If Window = 0 Then _
        Exit Property
    m_strBuffer = Space(256)
    GetWindowText Window, m_strBuffer, 256
    Caption = Trim(Left(m_strBuffer, InStr(1, m_strBuffer, Chr(0)) - 1))
End Property

Public Property Let Caption(ByVal v_strCaption As String)
    If Window = 0 Then _
        Exit Property
    SetWindowText Window, v_strCaption
End Property

Public Property Get InstanceHandle() As Long
    If Window = 0 Then _
        Exit Property
    InstanceHandle = GetWindowLong(Window, GWL_HINSTANCE)
End Property

Private Sub Class_Initialize()
    AddWindow Me
    Set WindowList = New CWindowList
    WindowList.AddWindow Me
End Sub

Private Sub Class_Terminate()
    RemoveWindow Me
    WindowList.RemoveWindow Me
End Sub

Public Property Get OldWndProc() As Long
    OldWndProc = m_lngWindowProc
End Property

Friend Property Let OldWndProc(v_lngWindowProc As Long)
    m_lngWindowProc = v_lngWindowProc
End Property

Public Sub Hook()
    If m_booHooked Then _
        Exit Sub
    Dim m_cwdWindow As CWindow
    Set m_cwdWindow = GetWindow(Window)
    If Not m_cwdWindow Is Nothing Then
        If Not m_cwdWindow Is Me And m_cwdWindow.Hooked Then
            WindowList.RemoveWindow Me
            Set WindowList = GetWindow(Window).WindowList
            WindowList.AddWindow Me
        End If
    End If
    m_lngWindowProc = SetWindowLong(Window, GWL_WNDPROC, AddressOf modWindowProc.WindowProcedure)
    m_booHooked = True
End Sub

Public Sub UnHook()
    If Not m_booHooked Then _
        Exit Sub
    m_booHooked = False
    If Not WindowListIndex = 1 Then
        If WindowListIndex = WindowList.Count Then
            WindowList.Remove WindowListIndex
            '//Update last item's window procedure
            WindowList.Item(WindowList.Count).OldWndProc = OldWndProc
        Else
            WindowList.Remove WindowListIndex
        End If
        Set WindowList = New CWindowList
        WindowList.AddWindow Me
    ElseIf Not WindowListIndex = WindowList.Count Then
        Call SetWindowLong(Window, GWL_WNDPROC, OldWndProc)
        WindowList.Remove WindowListIndex
        Set WindowList = New CWindowList
        WindowList.AddWindow Me
    ElseIf WindowList.FirstIndex Is Me And WindowList.LastIndex Is Me Then
        Call SetWindowLong(Window, GWL_WNDPROC, m_lngWindowProc)
        Set WindowList = New CWindowList
        WindowList.AddWindow Me
    End If
    m_lngWindowProc = 0
End Sub

Friend Sub WindowProcedure(ByRef Message As WindowsMessages, ByRef wParam As Long, ByRef OtherData As Long, ByRef WindowProcResult As Long)
    RaiseEvent WindowsProcedure(Message, wParam, OtherData, WindowProcResult)
    If Not OldWndProc = AddressOfItem(AddressOf modWindowProc.WindowProcedure) Then
        WindowProcResult = CallWindowProc(m_lngWindowProc, Window, Message, wParam, OtherData)
    End If
End Sub

Public Property Get WindowList() As CWindowList
    Set WindowList = r_cwlWindowList
End Property

Friend Property Let WindowList(ByVal v_cwlWindowList As CWindowList)
    Set r_cwlWindowList = v_cwlWindowList
End Property

Friend Property Set WindowList(ByVal v_cwlWindowList As CWindowList)
    Set r_cwlWindowList = v_cwlWindowList
End Property

Public Property Get Hooked() As Boolean
    Hooked = m_booHooked
End Property

Public Property Get WindowListIndex() As Long
    WindowListIndex = WindowList.ReturnWindowIndex(Me)
End Property
